local Recount2 = Recount2

--Bit Flags allows converting from text to bits
Recount2.BitFlags={}

Recount2.BitFlags.Type = {
	["Hit"]		= 0x00001,
	["Crit"]	= 0x00002,
	["Miss"]	= 0x00004,
	["Dodge"]	= 0x00008,
	["Parry"]	= 0x00010,
	["Block"]	= 0x00020,
	["Glancing"]	= 0x00040,
	["Crushing"]	= 0x00080,
	["Tick"]	= 0x00100,
	["Resist"]	= 0x00200,
	["Leech"]	= 0x00400,
	["Drain"]	= 0x00800,
	["Split"]	= 0x01000,
	["Absorb"]	= 0x02000,
	["Evade"]	= 0x04000,
	["Immune"]	= 0x08000,
	["Reflect"]	= 0x10000,
	["Deflect"]	= 0x20000,

	["HIT"]		= 0x00001,
	["CRIT"]	= 0x00002,
	["MISS"]	= 0x00004,
	["DODGE"]	= 0x00008,
	["PARRY"]	= 0x00010,
	["BLOCK"]	= 0x00020,
	["GLANCING"]	= 0x00040,
	["CRUSHING"]	= 0x00080,
	["TICK"]	= 0x00100,
	["RESIST"]	= 0x00200,
	["LEECH"]	= 0x00400,
	["DRAIN"]	= 0x00800,
	["SPLIT"]	= 0x01000,
	["ABSORB"]	= 0x02000,
	["EVADE"]	= 0x04000,
	["IMMUNE"]	= 0x08000,
	["REFLECT"]	= 0x10000,
	["DEFLECT"]	= 0x20000,
}

local POWERTYPE_MANA = 0
local POWERTYPE_RAGE = 1
local POWERTYPE_FOCUS = 2
local POWERTYPE_ENERGY = 3
local POWERTYPE_HAPPINESS = 4

Recount2.BitFlags.Power={
	[POWERTYPE_MANA]	= 0x01,
	[POWERTYPE_RAGE]	= 0x02,
	[POWERTYPE_ENERGY]	= 0x04,
	[POWERTYPE_FOCUS]	= 0x08,
	[POWERTYPE_HAPPINESS]	= 0x10,
	["Mana"]		= 0x01,
	["Rage"]		= 0x02,
	["Energy"]		= 0x04,
	["Focus"]		= 0x08,
	["Happiness"]		= 0x10,
}

Recount2.BitFlags.Info = {
	['Damage']	= 0x01,
	['Healing']	= 0x02,
	['Extra Attack']= 0x04,
	['Environment']	= 0x08,
	['Power Gain']	= 0x10,
	['Power Drain']	= 0x20,
}

--GroupNames allows converting from the bit flags to the text
Recount2.GroupNames={}

Recount2.GroupNames.Type = {
	[0x00001]	= 'Hit',
	[0x00002]	= 'Crit',
	[0x00004]	= 'Miss',
	[0x00008]	= 'Dodge',
	[0x00010]	= 'Parry',
	[0x00020]	= 'Block',
	[0x00040]	= 'Glancing',
	[0x00080]	= 'Crushing',
	[0x00100]	= 'Tick',
	[0x00200]	= 'Resist',
	[0x00400]	= 'Leech',
	[0x00800]	= 'Drain',
	[0x01000]	= 'Split',
	[0x02000]	= 'Absorb',
	[0x04000]	= 'Evade',
	[0x08000]	= 'Immune',
	[0x10000]	= 'Reflect',
	[0x20000]	= 'Deflect',
}

Recount2.GroupNames.Power={
	[0x01]	= 'Mana',
	[0x02]	= 'Rage',
	[0x04]	= 'Energy',
	[0x08]	= 'Focus',
	[0x10]	= 'Happiness',
}

Recount2.GroupNames.School={
	[0x01]	= 'Physical',
	[0x02]	= 'Holy',
	[0x04]	= 'Fire',
	[0x08]	= 'Nature',
	[0x10]	= 'Frost',
	[0x20]  = 'Shadow',
	[0x40]	= 'Arcane',
}

Recount2.GroupNames.Info={
	[0x01]	= 'Damage',
	[0x02]	= 'Healing',
	[0x04]	= 'Extra Attack',
	[0x08]	= 'Environment',
	[0x10]	= 'Power Gain',
	[0x20]  = 'Power Drain',
}

Recount2.Const = {}

Recount2.Const.ClassNames = {
	'DRUID',
	'HUNTER',
	'MAGE',
	'PALADIN',
	'PRIEST',
	'ROGUE',
	'SHAMAN',
	'WARLOCK',
	'WARRIOR',
}

Recount2.Const.Groups = {
	{
		'Source GUID',
		'Source Name',
		'Source Class',
		'Source Level',
		'Source Faction',
		'Source Race',
		'Source Classification',
		'Source Creature Type',
		'Source Creature Family',
		'Source Sex',
		'Source Trivial',
	},
	{
		'Target GUID',
		'Target Name',
		'Target Class',
		'Target Level',
		'Target Faction',
		'Target Race',
		'Target Classification',
		'Target Creature Type',
		'Target Creature Family',
		'Target Sex',
		'Target Trivial',
	},
	{
		'Ability',
		'Hit Type',
		'Info',
		'Power',
		'School',
	},
}

Recount2.Const.Race = {
	'BloodElf',
	'Draenei',
	'Dwarf',
	'Gnome',
	'Human',
	'NightElf',
	'Orc',
	'Tauren',
	'Troll',
	'Scourge',
	'Unknown',
	}

Recount2.Const.Faction = {
	'Alliance',
	'Horde',
	'Unknown',
	}

Recount2.Const.Affiliation = {
	'Mine',
	'Party',
	'Raid',
	'Others',
	}

Recount2.Const.Reaction = {
	'Friendly',
	'Neutral',
	'Hostile',
	}

Recount2.Const.EventTypes = {
	'Damage',
	'Healing',
	'Misses',
	'Power Gains',
	}
